#!/bin/sh
SCRDIR=`dirname $0`
if [ ! $1 ];then
	echo "Usage: mkrootfs.sh rootfs.ext2"
	exit
fi
if [ -e /tmp/mkrootfs ];then
	echo "/tmp/mkrootfs is exist."
	exit
fi
if [ $UID != 0 ];then
	echo "root required."
	exit
fi
mkdir /tmp/mkrootfs
mkdir /tmp/mkrootfs/mnt1
mkdir /tmp/mkrootfs/mnt2
dd if=/dev/zero of=$SCRDIR/rootfs.ext2 bs=1M count=20
dd if=/dev/zero of=$SCRDIR/rw.ext2 bs=1M count=2
mkfs.ext2 $SCRDIR/rootfs.ext2
mkfs.ext2 $SCRDIR/rw.ext2
mount $1 /tmp/mkrootfs/mnt1
mount $SCRDIR/rootfs.ext2 /tmp/mkrootfs/mnt2
cp -a /tmp/mkrootfs/mnt1/* /tmp/mkrootfs/mnt2
rm -rf /tmp/mkrootfs/mnt2/lost+found
rm -rf /tmp/mkrootfs/mnt2/etc/*
rm -rf /tmp/mkrootfs/mnt2/root/*
rm -rf /tmp/mkrootfs/mnt2/run/*
rm -rf /tmp/mkrootfs/mnt2/var/*
rm -rf /tmp/mkrootfs/mnt2/lib/modules/*/*
mkdir /tmp/mkrootfs/mnt2/home
mkdir /tmp/mkrootfs/mnt2/mnt/rw
mkdir /tmp/mkrootfs/mnt2/mnt/sd
VER=`ls /tmp/mkrootfs/mnt2/lib/modules|tr -d "\n"`
cp -r $SCRDIR/modules/* /tmp/mkrootfs/mnt2/lib/modules/$VER
ln -s /mnt/rw/modules.dep /tmp/mkrootfs/mnt2/lib/modules/$VER/modules.dep
cp $SCRDIR/init.sh /tmp/mkrootfs/mnt2
chmod 744 /tmp/mkrootfs/mnt2/init.sh
rm -f $SCRDIR/rootfs.squashfs
mksquashfs /tmp/mkrootfs/mnt2 $SCRDIR/rootfs.squashfs -comp xz -b 1m
umount /tmp/mkrootfs/mnt2
mount $SCRDIR/rw.ext2 /tmp/mkrootfs/mnt2
rm -rf /tmp/mkrootfs/mnt2/lost+found
cp -a /tmp/mkrootfs/mnt1/etc /tmp/mkrootfs/mnt2
cp -a /tmp/mkrootfs/mnt1/var /tmp/mkrootfs/mnt2
rm /tmp/mkrootfs/mnt2/var/log
mkdir /tmp/mkrootfs/mnt2/var/log
mkdir /tmp/mkrootfs/mnt2/home
mkfs.jffs2 -X zlib -r /tmp/mkrootfs/mnt2 -o $SCRDIR/rw.jffs2
umount /tmp/mkrootfs/mnt2
umount /tmp/mkrootfs/mnt1
rm -rf /tmp/mkrootfs
